import java.util.ArrayList;
import java.awt.image.*;
import java.awt.*;

public class Battle
{
	public ArrayList<pSquad> pSquads = new ArrayList<pSquad>();
	public ArrayList<eSquad> eSquads = new ArrayList<eSquad>();
	public ArrayList<Shot> pShots = new ArrayList<Shot>();
	public ArrayList<Shot> eShots = new ArrayList<Shot>();
	public ArrayList<Particle> particles = new ArrayList<Particle>();

	public ArrayList<SquadRecord> eRecord = new ArrayList<SquadRecord>();
	public ArrayList<SquadRecord> pRecord = new ArrayList<SquadRecord>();

	public long pauseTimer = 0;
	public final long turnLength = 10000;
	public boolean paused = true;

	public Battle(){}

	public void explode(int type, int num, double x, double y, double spread, int duration, double shipr, double shipspeed) // add particles, duration>=100
	{
		for(int i = 0; i < num; i++)
		{
			double myr = Math.random()*Math.PI*2;
			particles.add(new Particle(type, x, y, Math.random()*Math.cos(myr)*spread, Math.random()*Math.sin(myr)*spread, (int)(Math.random()*200.0) + duration - 100, shipspeed * Math.cos(shipr), shipspeed * Math.sin(shipr)));
		}
	}

	public void save()
	{
		eRecord = new ArrayList<SquadRecord>();
		pRecord = new ArrayList<SquadRecord>();

		for(eSquad es : eSquads)
		{
			eRecord.add(new SquadRecord((int)es.x, (int)es.y, es.shipType, null, es.shipImage));
		}

		for(pSquad ps : pSquads)
		{
			pRecord.add(new SquadRecord((int)ps.x, (int)ps.y, ps.shipType, ps.color, ps.shipImage));
		}
	}

	public void reload()
	{
		pSquads = new ArrayList<pSquad>();
		eSquads = new ArrayList<eSquad>();
		pShots = new ArrayList<Shot>();
		eShots = new ArrayList<Shot>();
		particles = new ArrayList<Particle>();

		for(SquadRecord record : eRecord)
		{
			eSquads.add(new eSquad(record.x, record.y, record.type, record.image));
		}

		for(SquadRecord record : pRecord)
		{
			pSquads.add(new pSquad(record.x, record.y, record.type, record.color, record.image));
		}
		
		pauseTimer = 0;
		paused = true;
	}

	private class SquadRecord
	{
		public int x;
		public int y;
		public int type;
		public Color color;
		public BufferedImage image;
		
		public SquadRecord(int x2, int y2, int type2, Color color2, BufferedImage image2)
		{
			x = x2;
			y = y2;
			type = type2;
			color = color2;
			image = image2;
		}
	}

}



