
import java.util.ArrayList;

public class Shot
{
	public int shotType;
	public double x;
	public double y;
	public double xspeed;
	public double yspeed;
	public int size;
	public int damage;

	public Shot(int type, double myx, double myy, double xs, double ys, int s, int dam)
	{
		shotType = type;
		x = myx;
		y = myy;
		xspeed = xs;
		yspeed = ys;
		size = s;
		damage = dam;
	}

	public boolean ecalc(int intstep, ArrayList<pSquad> squads)
	{
		double step = (double)intstep;
		// move shot
		x += xspeed*step;
		y += yspeed*step;

		if(x < -10 || x > 810 || y < -10 || y > 610)
			return true; // kill shot, OOB

		// collision detection
		for(pSquad ps : squads)
		{
			for(Ship ship : ps.ships)
			{
				double shipx = ps.x + ship.osx;
				double shipy = ps.y + ship.osy;
				double distSq = (x-shipx)*(x-shipx) + (y-shipy)*(y-shipy);
				double radSq = (((double)size + (double)ship.size)/2.0)*(((double)size + (double)ship.size)/2.0);
				if(distSq <= radSq) //hit
				{
					ship.health -= damage;
					return true;
				}
			
			}
		}
		return false;
	}

	public boolean pcalc(int intstep, ArrayList<eSquad> squads)
	{
		double step = (double)intstep;
		// move shot
		x += xspeed*step;
		y += yspeed*step;

		if(x < -10 || x > 810 || y < -10 || y > 610)
			return true; // kill shot, OOB

		// collision detection
		for(eSquad es : squads)
		{
			for(Ship ship : es.ships)
			{
				double shipx = es.x + ship.osx;
				double shipy = es.y + ship.osy;
				double distSq = (x-shipx)*(x-shipx) + (y-shipy)*(y-shipy);
				double radSq = (((double)size + (double)ship.size)/2.0)*(((double)size + (double)ship.size)/2.0);
				if(distSq <= radSq) //hit
				{
					ship.health -= damage;
					return true;
				}
			
			}
		}
		return false;
	}


}











